unit BoldDM;

interface

uses
  SysUtils, Classes, BoldPersistenceHandle, BoldPersistenceHandleFile,
  BoldPersistenceHandleFileXML, BoldAbstractModel, BoldModel, BoldHandles,
  BoldSystemHandle, BoldSubscription, BoldHandle, BoldUMLModelLink,
  BoldUMLXMILink, DB, IBDatabase, BoldAbstractPersistenceHandleDB,
  BoldPersistenceHandleDB, BoldAbstractDatabaseAdapter,
  BoldDatabaseAdapterIB, BoldTypeNameHandle, BusinessClasses,
  BoldAttributes, BoldSystem, ExtCtrls;

type
  TDataModule1 = class(TDataModule)
    BoldUMLXMILink1: TBoldUMLXMILink;
    BoldSystemTypeInfoHandle1: TBoldSystemTypeInfoHandle;
    BoldSystemHandle1: TBoldSystemHandle;
    BoldModel1: TBoldModel;
    BoldDatabaseAdapterIB1: TBoldDatabaseAdapterIB;
    BoldPersistenceHandleDB1: TBoldPersistenceHandleDB;
    IBDatabase1: TIBDatabase;
    BoldTypeNameHandle1: TBoldTypeNameHandle;
    Timer1: TTimer;
    procedure DataModuleDestroy(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    FOrderBook: TOrderBook;
    FTicker: TBADateTime;
    procedure EnsureSingletons;
  public
    { Public declarations }
  end;

var
  DataModule1: TDataModule1;

implementation

{$R *.dfm}

procedure TDataModule1.DataModuleDestroy(Sender: TObject);
begin
  FTicker.Free;
  BoldSystemHandle1.UpdateDatabase;
end;

procedure TDataModule1.EnsureSingletons;
var
  OrderBooks: TBoldObjectList;
begin
  OrderBooks := TBoldObjectList.Create;
  try
    BoldSystemHandle1.System.GetAllInClass(OrderBooks, TOrderBook);
    while OrderBooks.Count > 1 do
      OrderBooks[OrderBooks.Count-1].Delete;
    if OrderBooks.Count = 0 then
      begin
        FOrderBook := TOrderBook.Create(nil);
        BoldSystemHandle1.UpdateDatabase;
      end
    else
      FOrderBook := OrderBooks[0] as TOrderBook;
  finally
    OrderBooks.Free;
  end;
end;

procedure TDataModule1.DataModuleCreate(Sender: TObject);
begin
  FTicker := TBADateTime.Create;
  BoldSystemHandle1.System.Evaluator.DefineVariable('clock', FTicker, FTicker.BoldType, False);
end;

procedure TDataModule1.Timer1Timer(Sender: TObject);
begin
  FTicker.AsDateTime := Now;
end;

end.
